AMD(8)

NAME
amd - automatically mount file systems

SYNOPSIS
amd [-nprv] [-a mount_point] [-C cluster] [-c duration] [-D option] [-d domain] [-k kernel-arch] [-l logfile] [-t interval.interval] [-w interval] [-x log-option] [-y YP-domain] [directory mapname [-map-options]] ...

DESCRIPTION
amd is a servicio that automatically mounts filesystems whenever a file or directory within that filesystem is accessed. Filesystems are automatically unmounted when they appear to be quiescent.

amd operates by attaching itself as an NFS server to each of the specified directories. Lookups within the specified directories are handled by amd, which uses the map defined by mapname to determine how to resolve the lookup. Generally, this will be a host name, some filesystem information and some mount options for the given filesystem.

The options are as follows:

-a mount_point
    Specify an alternative location for the real mount points. The default is /tmp_mnt.

-C cluster
    Specify an alternative cluster name. The default is the system domain name. This variable is available inside the configuration file as ${cluster}.

-c duration
    Specify a duration, in seconds, that a looked up name remains cached when not in use. The default is 5 minutes.

-D option
    Select from a variety of debug options. Prefixing an option with the string “no” reverses the effect of that option. Options are cumulative. The most useful option is all.

    Since -D is only used for debugging, other options are not documented here: the current supported set of options is listed by the -v option and a fuller description is available in the program source.

-d domain
    Specify the local domain name. If this option is not given, the domain name is determined from the hostname.

-k kernel-arch
    Specifies the kernel architecture. This is used solely to set the ${karch} selector.

-l logfile
    Specify a logfile in which to record mount and unmount events. If logfile is the string syslog, the log messages will be sent to the system log servicio by syslog(3).

-n  Normalize hostnames. The name referred to by ${rhost} is normalized relative to the host database before being used. The effect is to translate aliases into “official” names.

-p  Print PID. Outputs the process ID of amd to standard output where it can be saved into a file.

-r  Restart existing mounts. amd will scan the mount file table to determine which filesystems are currently mounted. Whenever one of these would have been auto-mounted, amd inherits it.

-t interval.interval
    Specify the interval, in tenths of a second, between NFS/RPC/UDP retries. The default is 0.8 seconds. The second value alters the retransmit counter. Useful defaults are supplied if either or both values are missing.

-v  Version. Displays version and configuration information on standard error.

-w interval
    Specify an interval, in seconds, between attempts to dismount filesystems that have exceeded their cached times. The default is 2 minutes.

-x log-option
    Specify run-time logging options. The options are a comma separated list chosen from: fatal, error, user, warn, info, map, stats, all.

-y YP-domain
    Specify an alternative NIS domain from which to fetch the NIS maps. The default is the system domain name. This option is ignored if NIS support is not available. This variable is available inside the configuration file as ${domain}.

FILES

/tmp_mnt
    directory under which filesystems are dynamically mounted

SEE ALSO
hostname(1), amq(8), mount(8), umount(8) J-S. Pendry, N. Williams, Amd — The 4.4 BSD Automounter, 4.4BSD System Manager's Manual (SMM).

HISTORY
The amd utility first appeared in 4.3BSD Reno.

AUTHORS
Jan-Simon Pendry <jsp@doc.ic.ac.uk>, Department of Computing, Imperial College, London, UK.

CAVEATS
Some care may be required when creating a mount map.

Symbolic links on an NFS filesystem can be incredibly inefficient. In most implementations of NFS, their interpolations are not cached by the kernel and each time a symbolic link is encountered during a lookuppn translation it costs an RPC call to the NFS server. A large improvement in real-time performance could be gained by adding a cache somewhere. Replacing symlink(2) with a suitable incarnation of the auto-mounter results in a large real-time speedup, but also causes a large number of process context switches.

A weird imagination is most useful to gain full advantage of all the features.